Package com.collabnet.ce.soap60.webservices.pluggable

# Class PluggableAppSoap

java.lang.Object
com.collabnet.ce.soap60.webservices.WebService
com.collabnet.ce.soap60.webservices.pluggable.PluggableAppSoap

All Implemented Interfaces:
  `IPluggableAppSoap`

public class PluggableAppSoap extends WebService implements IPluggableAppSoap
The web service providing pluggable features.

Change History
Version 20.3

- getBaseUrlByName: Gets base url for given integrated application name

Version 17.11

- deleteIntegratedApplication: Delete an integrated application at the site level.

Version 16.7

- createIntegratedApplication6: Added to include support for integrated application license changes.
- createIntegratedApplicationFromXMLFiles6: Added to include support for integrated application license changes
- getIntegratedApplicationByName5: Added to return `PluggableComponent5SoapDO`
- editIntegratedApplication5: Added to edit an Integrated Application with license changes for an integrated application

Version 8.0

- createIntegratedApplication5: Added to include support for integrated application category and isbaseapp.
- createIntegratedApplicationFromXMLFiles5: Added to include support for integrated application category and isbaseapp
- getIntegratedApplicationByName4: Added to return `PluggableComponent4SoapDO`
- editIntegratedApplication4: Added to edit an Integrated Application with category and isbaseapp for an integrated application
- listPluggableComponents2: Added to list all the Integrated applications.
- listPluggableComponentsByCategory: Added to list Integrated applications based on the category.
- setIntegratedApplicationIcon: Sets new icon for specified integrated application.

Version 7.2

- createIntegratedApplication4: Added in 7.2 to include support for global configuration parameters and resource bundles.
- createIntegratedApplicationFromXMLFiles4: Added in 7.2 to include support for global configuration parameters.
- getIntegratedApplicationByName3: Added in 7.2 to return `PluggableComponent3SoapDO`
- editIntegratedApplication3: Added in 7.2 to edit an Integrated Application with global configuration parameters and resource bundles.

Version 7.0

- createIntegratedApplication3: Added in 7.0 to include icon file key, icon file name and icon mime-type as input parameters.
- createIntegratedApplicationFromXMLFiles3: Added in 7.0 to include icon file key, icon file name and icon mime-type as input parameters.

Version 6.1.1

- createIntegratedApplication2: Added in 6.1.1 to included the newer parameters for creating an integrated application.
- editProjectConfigurationParameters2: Added in 6.1.1 to included an integrated application id as an input parameter.
- getIntegratedApplicationByName2: Added in 6.1.1 to return `PluggableComponent2SoapDO`
- editIntegratedApplication2: Added in 6.1.1 to allow editing the newer parameters include for creating an integrated application
- createIntegratedApplicationFromXMLFiles2: Added in 6.1.1 to return `PluggableComponent2SoapDO`

Version 6.1

- createIntegratedApplicationFromXMLFiles: New operation added in 6.1 to create/import an integrated application from xml files

Version 6.0.1

- getProjectPrefix: New operation added in 6.0.1 to get the project prefix of an integrated application
- updateRecentAccess: New operation added in 6.0.1 to update the recent access history of an user
- getIntegratedAppPrefixes: New operation added in 6.0.1 to get the list of Integrated App Prefixes.
- setPluggableAppMessageResource: New operation added in 6.0.1 to create / update the Pluggable App Message resource

Version 6.0

- createIntegratedApplication: New operation added in 6.0 to create an Integrated Application
- getIntegratedApplicationByName: New operation added in 6.0 to get the Integrated Application for the given Name
- editIntegratedApplication: New operation added in 6.0 to edit an Integrated Application
- getLinkPlugIdByPlugId: New operation added in 6.0 to get the integrated application id for the specified project and base URL.

Since:
  5.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PluggableAppSoap()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PluggableComponentSoapDO`
  `createIntegratedApplication(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplication2(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplication3(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileKey, String iconFileName, String iconMimeType, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `createIntegratedApplication4(String sessionId, PluggableComponent3SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `createIntegratedApplication5(String sessionId, PluggableComponent4SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `createIntegratedApplication6(String sessionId, PluggableComponent5SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Creates a Integrated Application Note that the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
  `PluggableComponentSoapDO`
  `createIntegratedApplicationFromXMLFiles(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplicationFromXMLFiles2(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplicationFromXMLFiles3(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `createIntegratedApplicationFromXMLFiles4(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `createIntegratedApplicationFromXMLFiles5(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `createIntegratedApplicationFromXMLFiles6(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Create/import an integrated application from XML files.
  `void`
  `deleteIntegratedApplication(String sessionId, String plugName)`
  Delete an integrated application at the site level
  `void`
  `editIntegratedApplication(String sessionId, PluggableComponentSoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication2(String sessionId, PluggableComponent2SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication3(String sessionId, PluggableComponent3SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication4(String sessionId, PluggableComponent4SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication5(String sessionId, PluggableComponent5SoapDO soapDO)`
  Edit the integrated application properties.
  `void`
  `editIntegratedApplicationFromXMLFiles(String sessionId, String integratedAppId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Edit integrated application from xml files.
  `SoapNamedValues`
  `editProjectConfigurationParameters(String sessionId, String projectId, PluggableComponentParameterSoapDO[] paramDO)`
  Deprecated.
  `SoapNamedValues`
  `editProjectConfigurationParameters2(String sessionId, String integratedAppId, String projectId, PluggableComponentParameterSoapDO[] paramDO)`
  Edit the project specific configuration parameters of an integrated application.
  `SoapNamedValues`
  `enablePluggableComponent(String sessionId, String projectID, String pluggableId, PluggableComponentParameterSoapDO[] params, String prefix)`
  Adds a pluggable application to a project
  `String`
  `getBaseUrlByLinkId(String sessionId, String linkId)`
  Get the project integrated application's base URL.
  `String`
  `getBaseUrlByName(String sessionId, String iaName)`
  Gets integrated application base url for the given IA Name
  `PluggableComponentSoapDO`
  `getIntegratedApplicationByName(String sessionId, String plugName)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `getIntegratedApplicationByName2(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `getIntegratedApplicationByName3(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `getIntegratedApplicationByName4(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `getIntegratedApplicationByName5(String sessionId, String integratedAppName)`
  Get the integrated application for a given name.
  `String[]`
  `getIntegratedAppPrefixes(String sessionId)`
  Gets the list of Integrated App Prefixes.
  `String`
  `getLinkPlugId(String sessionId, String projectPath, String baseUrl)`
  Gets the link id for the specified project and base URL.
  `String`
  `getLinkPlugIdByPlugId(String sessionId, String projectId, String pluggableId)`
  Get the integrated application id for the specified project and base URL.
  `String`
  `getPlugIdByBaseUrl(String sessionId, String baseUrl)`
  Gets integrated application id for the given base URL
  `PluggableComponentParameterSoapDO[]`
  `getProjectConfigParameterData(String sessionId, String linkId)`
  Gets project specific configuration parameters for a pluggable application.
  `String`
  `getProjectPathByIntegratedAppId(String sessionId, String linkId)`
  Get the project path for the given integrated application id.
  `String`
  `getProjectPrefix(String sessionId, String linkId)`
  Get the project prefix for an integrated application.
  `PluggableComponentSoapList`
  `listPluggableComponents(String sessionId)`
  Deprecated.
  `PluggableComponent2SoapList`
  `listPluggableComponents2(String sessionId)`
  Gets the list of integrated applications in the site.
  `PluggableComponent2SoapList`
  `listPluggableComponentsByCategory(String sessionId, String category)`
  Gets the list of integrated applications in the site based on the category.
  `LinkPluggableComponentSoapList`
  `listPluggableComponentsForProject(String sessionId, String projectId)`
  Lists Pluggable Components.
  `void`
  `removeProjectIntegratedApplication(String sessionId, String linkId)`
  Removes integrated application from a project.
  `void`
  `setIntegratedApplicationIcon(String sessionId, String integratedAppId, String iconFileKey, String iconFileName, String iconMimeType)`
  Sets new icon for specified integrated application
  `void`
  `setPluggableAppMessageResource(String sessionId, String pluggableId, String locale, String key, String value)`
  Creates / Updates the Pluggable App Message resource
  `void`
  `updateRecentAccess(String userId, String objectId)`
  Updates the recent access entries for the user.

  ### Methods inherited from class com.collabnet.ce.soap60.webservices.WebService

  `assertNormalProject, assertProjectGroup, canGiveFullUserDetails, checkGeneralPermission, checkPermission, checkPermission, checkSiteWidePermission, createUserSessionKey, downloadFile, filterInvalidProjMembers, generateFolderName, getAccessControlService, getApplicationRegistryService, getAttachment, getAuthenticationService, getCategorization, getCoreService, getDiscussion, getDocMan, getDocumentRootFolder, getFileStorageService, getFolderKey, getFolderPath, getFolderPath, getFolderPath, getFrs, getIntegrationData, getItemPath, getItemPath, getLocale, getMonitoring, getNews, getNulledMinSoapDate, getObjectKey, getObjectPath, getOperation, getPages, getPlanning, getPluggableComponent, getProjectId, getProjectPath, getProjectPath, getRbac, getSearch, getStoredFileSize, getStoredFileText, getTagService, getTeam, getTemplate, getTracker, getUser, getUserData, getUsername, getUserService, getWiki, hasPermission, hasSiteWidePermission, isFolderResource, isProjectGroup, isProjectId, isStrEmpty, isSuperUser, isValidEmail, makeStoredFileDO, makeStoredFileDOs, requireProjectAdminPermission, setPartialOrFullUserData, setUserNameToResponse, storeFile, storeTextFile, validateChoice, validateChoice, validateIconFile, validateString, validateStringArray, validateStringWithTrim, validateTokenAndExactUsername, validateTokenAndExactUsername, validateWikiPageName, verifyLicense`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PluggableAppSoap

    public PluggableAppSoap()

- ## Method Details

  - ### listPluggableComponents

    @Deprecated public PluggableComponentSoapList listPluggableComponents(String sessionId) throws InvalidSessionFault, PermissionDeniedFault, SystemFault
    Deprecated.
    Gets the list of integrated applications in the site.
    Specified by:
      `listPluggableComponents` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      5.0

  - ### listPluggableComponents2

    public PluggableComponent2SoapList listPluggableComponents2(String sessionId) throws InvalidSessionFault, SystemFault, PermissionDeniedFault
    Gets the list of integrated applications in the site.
    Specified by:
      `listPluggableComponents2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      8.0

  - ### listPluggableComponentsByCategory

    public PluggableComponent2SoapList listPluggableComponentsByCategory(String sessionId, String category) throws InvalidSessionFault, PermissionDeniedFault, SystemFault
    Gets the list of integrated applications in the site based on the category.
    Specified by:
      `listPluggableComponentsByCategory` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `category` - category of the integrated application.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      8.0

  - ### enablePluggableComponent

    public SoapNamedValues enablePluggableComponent(String sessionId, String projectID, String pluggableId, PluggableComponentParameterSoapDO[] params, String prefix) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault, IntegratedAppDisabledFault
    Adds a pluggable application to a project
    Specified by:
      `enablePluggableComponent` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `projectID` - Project ID project to which the pluggable app should be added.
      `pluggableId` - pluggable application that should be added to a project
      `params` - Param Array of PluggableComponentParameter Values
      `prefix` - the pluggablecomponent prefix
    Returns:
      name/value pair of validation errors if any, where name is the parameter name and value is the error string
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project/integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `IntegratedAppDisabledFault` - thrown when the integrated application is disabled from addition to projects
    Since:
      5.0

  - ### getProjectConfigParameterData

    public PluggableComponentParameterSoapDO[] getProjectConfigParameterData(String sessionId, String linkId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Gets project specific configuration parameters for a pluggable application.
    Specified by:
      `getProjectConfigParameterData` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - the link id between a pluggable application and a project
    Returns:
      array of project specific configuration parameters
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      5.0

  - ### editProjectConfigurationParameters

    @Deprecated public SoapNamedValues editProjectConfigurationParameters(String sessionId, String projectId, PluggableComponentParameterSoapDO[] paramDO) throws NoSuchObjectFault, InvalidSessionFault, PermissionDeniedFault, SystemFault
    Deprecated.
    Edits project specific configuration parameters of a pluggable application. Use getProjectConfigParameterData to get the existing configuration parameters for a pluggable application.
    Specified by:
      `editProjectConfigurationParameters` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - project in which the pluggable application resides.
      `paramDO` - project specific configuration parameters for a pluggable application
    Returns:
      name/value pair of validation errors if any, where name is the parameter name and value is the error string.
    Throws:
      `NoSuchObjectFault` - when the specified project id or the configuration params is invalid.
      `InvalidSessionFault` - when the specified session id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      5.0

  - ### editProjectConfigurationParameters2

    public SoapNamedValues editProjectConfigurationParameters2(String sessionId, String integratedAppId, String projectId, PluggableComponentParameterSoapDO[] paramDO) throws NoSuchObjectFault, InvalidSessionFault, PermissionDeniedFault, SystemFault
    Edit the project specific configuration parameters of an integrated application. Use the `getProjectConfigParameterData` to get the existing configuration parameters.
    Specified by:
      `editProjectConfigurationParameters2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - Soap session ID
      `integratedAppId` - integrated application ID
      `projectId` - project in which the integrated application resides
      `paramDO` - project specific configuration parameters of an integrated application
    Returns:
      name/value pair of validation errors if any, where name is the parameter name and value is the error string.
    Throws:
      `NoSuchObjectFault` - thrown if given project id or the configuration parameter is invalid.
      `InvalidSessionFault` - thrown if the soap session is invalid.
      `SystemFault` - thrown on the occurrence of an unexpected system level error.
      `PermissionDeniedFault` - thrown if the user has insufficient privileges.
    Since:
      6.1.1

  - ### deleteIntegratedApplication

    public void deleteIntegratedApplication(String sessionId, String plugName) throws InvalidSessionFault, PermissionDeniedFault, NoSuchObjectFault
    Delete an integrated application at the site level
    Specified by:
      `deleteIntegratedApplication` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `com.collabnet.ctf.common.exceptions.NoSuchObjectException` - thrown when the integrated application is not available
      `NoSuchObjectFault`
    Since:
      17.11

  - ### removeProjectIntegratedApplication

    public void removeProjectIntegratedApplication(String sessionId, String linkId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Removes integrated application from a project.
    Specified by:
      `removeProjectIntegratedApplication` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - project pluggable application id
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      5.0

  - ### listPluggableComponentsForProject

    public LinkPluggableComponentSoapList listPluggableComponentsForProject(String sessionId, String projectId) throws InvalidSessionFault, NoSuchObjectFault, PermissionDeniedFault, SystemFault
    Lists Pluggable Components. Gives the list of pluggable components available for a project
    Specified by:
      `listPluggableComponentsForProject` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - Project ID.
    Returns:
      pcList PluggableComponentList.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
    Since:
      5.0

  - ### getLinkPlugId

    public String getLinkPlugId(String sessionId, String projectPath, String baseUrl) throws InvalidSessionFault, NoSuchObjectFault, SystemFault, PermissionDeniedFault
    Gets the link id for the specified project and base URL.
    Specified by:
      `getLinkPlugId` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `projectPath` - the project path
      `baseUrl` - integrated application base URL
    Returns:
      integrated application id for the specified project and base URL
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - thrown when an association between the integrated application and the project does not exist
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      5.0

  - ### getProjectPathByIntegratedAppId

    public String getProjectPathByIntegratedAppId(String sessionId, String linkId) throws InvalidSessionFault, NoSuchObjectFault, SystemFault, PermissionDeniedFault
    Get the project path for the given integrated application id.
    Specified by:
      `getProjectPathByIntegratedAppId` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - linkId id of integrated application id/prpl id
    Returns:
      project path for the given integrated application.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application id is invalid
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      5.0

  - ### getBaseUrlByLinkId

    public String getBaseUrlByLinkId(String sessionId, String linkId) throws InvalidSessionFault, NoSuchObjectFault, SystemFault, PermissionDeniedFault
    Get the project integrated application's base URL.
    Specified by:
      `getBaseUrlByLinkId` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - project integrated application id.
    Returns:
      the project integrated application's base URL
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application id is invalid
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      5.0

  - ### getPlugIdByBaseUrl

    public String getPlugIdByBaseUrl(String sessionId, String baseUrl) throws InvalidSessionFault
    Gets integrated application id for the given base URL
    Specified by:
      `getPlugIdByBaseUrl` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `baseUrl` - integrated application base URL
    Returns:
      integrated application id
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
    Since:
      5.0

  - ### getBaseUrlByName

    public String getBaseUrlByName(String sessionId, String iaName) throws InvalidSessionFault, NoSuchObjectFault
    Gets integrated application base url for the given IA Name
    Specified by:
      `getBaseUrlByName` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `iaName` - integrated application name
    Returns:
      baseUrl
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault`
    Since:
      20.3

  - ### createIntegratedApplication

    @Deprecated public PluggableComponentSoapDO createIntegratedApplication(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault
    Deprecated.
    Creates a Integrated Application
    Specified by:
      `createIntegratedApplication` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileId` - the iconfileId
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration. the PluggableComponentParameterSoapDO
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
    Returns:
      a `PluggableComponentSoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
    Since:
      6.0

  - ### createIntegratedApplication2

    @Deprecated public PluggableComponent2SoapDO createIntegratedApplication2(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault
    Deprecated.
    Creates a Integrated Application
    Specified by:
      `createIntegratedApplication2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileId` - the iconfileId
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration.
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
      `idPattern` - Regular expression for the object id which used for creating association links.
      `serviceType` - The service type REST / SOAP
    Returns:
      a `PluggableComponent2SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
    Since:
      6.1.1

  - ### createIntegratedApplication3

    @Deprecated public PluggableComponent2SoapDO createIntegratedApplication3(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileKey, String iconFileName, String iconMimeType, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplication3` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration.
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
      `idPattern` - Regular expression for the object id which used for creating association links.
      `serviceType` - The service type REST / SOAP
    Returns:
      a `PluggableComponent2SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
      `com.collabnet.ctf.common.exceptions.ObjectAlreadyExistsException`
    Since:
      7.0

  - ### createIntegratedApplication4

    @Deprecated public PluggableComponent3SoapDO createIntegratedApplication4(String sessionId, PluggableComponent3SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplication4` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent3SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent3SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
    Since:
      7.2

  - ### createIntegratedApplication5

    @Deprecated public PluggableComponent4SoapDO createIntegratedApplication5(String sessionId, PluggableComponent4SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplication5` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent4SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent4SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
    Since:
      8.0

  - ### createIntegratedApplication6

    public PluggableComponent5SoapDO createIntegratedApplication6(String sessionId, PluggableComponent5SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, ObjectAlreadyExistsFault, SystemFault, NoSuchObjectFault
    Creates a Integrated Application Note that the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplication6` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent5SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent5SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
    Since:
      16.7

  - ### createIntegratedApplicationFromXMLFiles

    @Deprecated public PluggableComponentSoapDO createIntegratedApplicationFromXMLFiles(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault
    Deprecated.
    Creates/Imports an integrated application from xml files. Note that input xml files have to be uploaded as byte arrays
    Specified by:
      `createIntegratedApplicationFromXMLFiles` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - user session id
      `depXmlByteArray` - integrated app deployment xml byte array
      `appXmlByteArray` - integrated app application xml byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Returns:
      PluggableComponentSoapDO with the details of the integrated application that was created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
    Since:
      6.1

  - ### createIntegratedApplicationFromXMLFiles2

    @Deprecated public PluggableComponent2SoapDO createIntegratedApplicationFromXMLFiles2(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault
    Deprecated.
    Create/import an integrated application from XML files. Note that input XML files have to be uploaded as byte arrays
    Specified by:
      `createIntegratedApplicationFromXMLFiles2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Returns:
      a `PluggableComponent2SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
    Since:
      6.1.1

  - ### createIntegratedApplicationFromXMLFiles3

    @Deprecated public PluggableComponent2SoapDO createIntegratedApplicationFromXMLFiles3(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault, IllegalArgumentFault, NoSuchObjectFault
    Deprecated.
    Create/import an integrated application from XML files. Note that input XML files has to be uploaded as byte array and the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplicationFromXMLFiles3` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent2SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
    Since:
      7.0

  - ### createIntegratedApplicationFromXMLFiles4

    @Deprecated public PluggableComponent3SoapDO createIntegratedApplicationFromXMLFiles4(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault, IllegalArgumentFault, NoSuchObjectFault
    Deprecated.
    Create/import an integrated application from XML files. Note that input XML files has to be uploaded as byte array and the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplicationFromXMLFiles4` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent3SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
    Since:
      7.2

  - ### createIntegratedApplicationFromXMLFiles5

    @Deprecated public PluggableComponent4SoapDO createIntegratedApplicationFromXMLFiles5(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault, IllegalArgumentFault, NoSuchObjectFault
    Deprecated.
    Create/import an integrated application from XML files. Note that input XML files has to be uploaded as byte array and the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplicationFromXMLFiles5` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent4SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
    Since:
      8.0

  - ### createIntegratedApplicationFromXMLFiles6

    public PluggableComponent5SoapDO createIntegratedApplicationFromXMLFiles6(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, ObjectAlreadyExistsFault, SystemFault, IllegalArgumentFault, NoSuchObjectFault
    Create/import an integrated application from XML files. Note that input XML files has to be uploaded as byte array and the icon file has to be uploaded seperately (through FileStorageApp or SimpleFileStorageApp service) and the maximum size of the icon file is 10KB.
    Specified by:
      `createIntegratedApplicationFromXMLFiles6` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent5SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
    Since:
      16.7

  - ### getIntegratedApplicationByName

    @Deprecated public PluggableComponentSoapDO getIntegratedApplicationByName(String sessionId, String plugName) throws InvalidSessionFault, NoSuchObjectFault
    Deprecated.
    Returns the PluggableComponentSoapDO object for the given Integrated Application Name
    Specified by:
      `getIntegratedApplicationByName` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap sessionid
      `plugName` - the Integrated App Name
    Returns:
      PluggableComponentSoapDO object
    Throws:
      `InvalidSessionFault` - when the session is invalid.
      `NoSuchObjectFault`
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      6.0

  - ### getIntegratedApplicationByName2

    @Deprecated public PluggableComponent2SoapDO getIntegratedApplicationByName2(String sessionId, String integratedAppName) throws InvalidSessionFault, NoSuchObjectFault
    Deprecated.
    Get the integrated application for a given name.
    Specified by:
      `getIntegratedApplicationByName2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent2SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
    Since:
      6.1.1

  - ### getIntegratedApplicationByName3

    @Deprecated public PluggableComponent3SoapDO getIntegratedApplicationByName3(String sessionId, String integratedAppName) throws InvalidSessionFault, NoSuchObjectFault
    Deprecated.
    Get the integrated application for a given name.
    Specified by:
      `getIntegratedApplicationByName3` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent3SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
    Since:
      7.2

  - ### getIntegratedApplicationByName4

    @Deprecated public PluggableComponent4SoapDO getIntegratedApplicationByName4(String sessionId, String integratedAppName) throws InvalidSessionFault, NoSuchObjectFault
    Deprecated.
    Get the integrated application for a given name.
    Specified by:
      `getIntegratedApplicationByName4` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent4SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
    Since:
      8.0

  - ### getIntegratedApplicationByName5

    public PluggableComponent5SoapDO getIntegratedApplicationByName5(String sessionId, String integratedAppName) throws InvalidSessionFault, NoSuchObjectFault
    Get the integrated application for a given name.
    Specified by:
      `getIntegratedApplicationByName5` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent5SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
    Since:
      16.7

  - ### editIntegratedApplication

    @Deprecated public void editIntegratedApplication(String sessionId, PluggableComponentSoapDO soapDO) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault
    Deprecated.
    Edits the Integrated Application for the giving PluggableComponentSoapDO
    Specified by:
      `editIntegratedApplication` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the soap sessionId
      `soapDO` - the PluggableComponentSoapDO
    Throws:
      `InvalidSessionFault` - when session is invalid
      `PermissionDeniedFault` - when current user doesn't have enough permission
      `IllegalArgumentFault` - when given PluggableComponetSoapDO has invalid value
      `SystemFault` - when an unexpected system level error occurs.
      `NoSuchObjectFault` - when the integrated app with the given details does not exists.
    Since:
      6.0

  - ### editIntegratedApplication2

    @Deprecated public void editIntegratedApplication2(String sessionId, PluggableComponent2SoapDO soapDO) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Edit the integrated application properties.
    Specified by:
      `editIntegratedApplication2` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent2SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
    Since:
      6.1.1

  - ### editIntegratedApplication3

    @Deprecated public void editIntegratedApplication3(String sessionId, PluggableComponent3SoapDO soapDO) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Edit the integrated application properties.
    Specified by:
      `editIntegratedApplication3` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent3SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
    Since:
      7.2

  - ### editIntegratedApplication4

    @Deprecated public void editIntegratedApplication4(String sessionId, PluggableComponent4SoapDO soapDO) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault, NoSuchObjectFault
    Deprecated.
    Edit the integrated application properties.
    Specified by:
      `editIntegratedApplication4` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent4SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
    Since:
      8.0

  - ### editIntegratedApplication5

    public void editIntegratedApplication5(String sessionId, PluggableComponent5SoapDO soapDO) throws InvalidSessionFault, PermissionDeniedFault, IllegalArgumentFault, SystemFault, NoSuchObjectFault
    Edit the integrated application properties.
    Specified by:
      `editIntegratedApplication5` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent5SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
    Since:
      16.7

  - ### editIntegratedApplicationFromXMLFiles

    public void editIntegratedApplicationFromXMLFiles(String sessionId, String integratedAppId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws InvalidSessionFault, PermissionDeniedFault, NoSuchObjectFault, SystemFault, IllegalArgumentFault
    Edit integrated application from xml files. Note that input xml files have to be uploaded as byte arrays
    Specified by:
      `editIntegratedApplicationFromXMLFiles` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - user session id
      `depXmlByteArray` - integrated app deployment xml byte array
      `appXmlByteArray` - integrated app application xml byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `NoSuchObjectFault` - thrown when an application doesn not exists with the given id
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
    Since:
      6.1.1

  - ### setIntegratedApplicationIcon

    public void setIntegratedApplicationIcon(String sessionId, String integratedAppId, String iconFileKey, String iconFileName, String iconMimeType) throws InvalidSessionFault, PermissionDeniedFault, SystemFault, IllegalArgumentFault, NoSuchObjectFault
    Sets new icon for specified integrated application
    Specified by:
      `setIntegratedApplicationIcon` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - soap session ID
      `integratedAppId` - integrated application for which the icon to be set
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service).
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG and the maximum size of the icon file is 10KB)
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault` - thrown if any of the parameters is not set
      `NoSuchObjectFault` - thrown when the specified integrated application does not exist.
    Since:
      8.0

  - ### getLinkPlugIdByPlugId

    public String getLinkPlugIdByPlugId(String sessionId, String projectId, String pluggableId) throws InvalidSessionFault, NoSuchObjectFault, SystemFault, PermissionDeniedFault
    Get the integrated application id for the specified project and base URL.
    Specified by:
      `getLinkPlugIdByPlugId` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - the project ID
      `pluggableId` - integrated application ID.
    Returns:
      integrated application link id for the specified project and pluggableId
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault`
    Since:
      6.0

  - ### getProjectPrefix

    public String getProjectPrefix(String sessionId, String linkId) throws InvalidSessionFault, NoSuchObjectFault, SystemFault, PermissionDeniedFault
    Get the project prefix for an integrated application.
    Specified by:
      `getProjectPrefix` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - UserSession Id.
      `linkId` - , integrated application link id
    Returns:
      project prefix for an integrated application.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application does not exist.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
    Since:
      6.0.1

  - ### updateRecentAccess

    public void updateRecentAccess(String userId, String objectId) throws IllegalArgumentFault
    Updates the recent access entries for the user.
    Specified by:
      `updateRecentAccess` in interface `IPluggableAppSoap`
    Parameters:
      `userId` - user who recently accessed this object
      `objectId` - recently accessed object id of the form glpl_prplXXXX_prefix_objectId_objectTitle
    Throws:
      `IllegalArgumentFault` - thrown when the objectId is invalid
    Since:
      6.0.1

  - ### getIntegratedAppPrefixes

    public String[] getIntegratedAppPrefixes(String sessionId) throws InvalidSessionFault
    Gets the list of Integrated App Prefixes.
    Specified by:
      `getIntegratedAppPrefixes` in interface `IPluggableAppSoap`
    Parameters:
      `sessionId` - the Session id of the user
    Returns:
      Array List of Integrated App Prefixes.
    Throws:
      `InvalidSessionFault` - when session is invalid
    Since:
      6.0.1

  - ### setPluggableAppMessageResource

    public void setPluggableAppMessageResource(String sessionId, String pluggableId, String locale, String key, String value) throws InvalidSessionFault, PermissionDeniedFault
    Creates / Updates the Pluggable App Message resource
    Specified by:
      `setPluggableAppMessageResource` in interface `IPluggableAppSoap`
    Parameters:
      `pluggableId` - The Pluggable Id for which this message resource to be created
      `locale` - The Locale
      `key` - The Resource Key
      `value` - The Resource Value
    Throws:
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidSessionFault`
    Since:
      6.0.1